package com.vendor.platform.ui.internal;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.File;
import java.util.StringTokenizer;
import org.eclipse.jface.layout.TableColumnLayout;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.CheckboxTableViewer;
import org.eclipse.jface.viewers.ColumnLayoutData;
import org.eclipse.jface.viewers.ColumnWeightData;
import org.eclipse.jface.viewers.ListViewer;
import org.eclipse.jface.viewers.TableLayout;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.custom.CCombo;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Drawable;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.DateTime;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.ui.PlatformUI;

public class ControlFactory {
  public static File openFileDialog(Shell shell, File startingDirectory, File filterPath, String[] extensions) {
    FileDialog dialog = new FileDialog(shell, 268439552);
    if (startingDirectory != null) {
      dialog.setFileName(startingDirectory.getPath());
    } else if (filterPath != null) {
      dialog.setFilterPath(filterPath.getPath());
    } 
    if (extensions != null)
      dialog.setFilterExtensions(extensions); 
    String file = dialog.open();
    if (file != null) {
      file = file.trim();
      if (file.length() > 0)
        return new File(file); 
    } 
    return null;
  }
  
  public static Text createFileField(Composite parent, String label, String buttonText, SelectionListener l) {
    Text text = createLabeledText(parent, label, 0, null);
    createPushButton(parent, buttonText, (SelectionListener)new Object(text, parent, l));
    return text;
  }
  
  public static Text createFileFieldWithWidth(Composite parent, String label, String buttonText, int labelWidthHint, SelectionListener l) {
    Text text = createLabeledTextWithWidth(parent, label, 0, labelWidthHint, null);
    createPushButton(parent, buttonText, (SelectionListener)new Object(text, parent, l));
    return text;
  }
  
  public static DateTime createDateField(Composite parent, String label) {
    Label lbl = new Label(parent, 0);
    lbl.setLayoutData(new GridData(1, 16777216, false, false));
    lbl.setText(label);
    DateTime date = new DateTime(parent, 2080);
    date.setLayoutData(new GridData(4, 16777216, false, false));
    return date;
  }
  
  public static Text createLabeledText(Composite parent, String label, int style, ModifyListener listener) {
    Label lbl = new Label(parent, 0);
    lbl.setLayoutData(new GridData(1, 16777216, false, false));
    lbl.setText(label);
    Object object = new Object(parent, 0x800 | style, lbl);
    object.setLayoutData(new GridData(4, 16777216, true, false));
    if (listener != null)
      object.addModifyListener(listener); 
    return (Text)object;
  }
  
  public static Text createLabeledTextWithWidth(Composite parent, String label, int style, int labelWidthHint, ModifyListener listener) {
    Label lbl = new Label(parent, 0);
    GridData gridData = new GridData(1, 16777216, false, false);
    gridData.widthHint = labelWidthHint;
    lbl.setLayoutData(gridData);
    lbl.setText(label);
    Object object = new Object(parent, 0x800 | style, lbl);
    object.setLayoutData(new GridData(4, 16777216, true, false));
    if (listener != null)
      object.addModifyListener(listener); 
    return (Text)object;
  }
  
  public static Button createPushButton(Composite parent, String key, SelectionListener listener) {
    Button button = new Button(parent, 8);
    if (key != null)
      button.setText(JFaceResources.getString(key)); 
    button.setFont(parent.getFont());
    if (listener != null)
      button.addSelectionListener(listener); 
    return button;
  }
  
  public static SashForm createSashForm(Composite parent, int style) {
    SashForm sashForm = new SashForm(parent, style);
    GridData data = new GridData(1808);
    sashForm.setLayoutData(data);
    return sashForm;
  }
  
  public static Composite createComposite(Composite parent, int numColumns) {
    return createCompositeEx(parent, numColumns, 768, 1);
  }
  
  public static Composite createCompositeEx(Composite parent, int numColumns, int layoutMode, int span) {
    Composite composite = new Composite(parent, 0);
    composite.setFont(parent.getFont());
    composite.setLayout((Layout)new GridLayout(numColumns, false));
    GridData gd = new GridData(layoutMode);
    gd.horizontalSpan = span;
    composite.setLayoutData(gd);
    return composite;
  }
  
  public static Composite createCompositeEx(SashForm parent, int numColumns, int layoutMode, int span) {
    Composite composite = new Composite((Composite)parent, 0);
    composite.setFont(parent.getFont());
    composite.setLayout((Layout)new GridLayout(numColumns, false));
    return composite;
  }
  
  public static Composite createComposite(Composite parent, int numColumns, int style, int layoutMode, int span) {
    Composite composite = new Composite(parent, style);
    composite.setFont(parent.getFont());
    composite.setLayout((Layout)new GridLayout(numColumns, false));
    GridData gd = new GridData(layoutMode);
    gd.horizontalSpan = span;
    composite.setLayoutData(gd);
    return composite;
  }
  
  public static Label createLabel(Composite parent, String text, int widthHint, int heightHint, int style, int span) {
    Label label = new Label(parent, style);
    label.setFont(parent.getFont());
    label.setText(text);
    GridData gd = new GridData(768);
    gd.horizontalSpan = span;
    gd.widthHint = widthHint;
    gd.heightHint = heightHint;
    label.setLayoutData(gd);
    return label;
  }
  
  public static Label createLabel(Composite parent, String text, int span) {
    return createLabel(parent, text, -1, -1, 16384, span);
  }
  
  public static Button createCheckBox(Composite group, String label) {
    Button button = new Button(group, 16416);
    button.setFont(group.getFont());
    button.setText(label);
    GridData data = new GridData();
    button.setLayoutData(data);
    button.setBackground(group.getBackground());
    button.setForeground(group.getForeground());
    return button;
  }
  
  public static Button createRadioButton(Composite group, String label, String value, SelectionListener listener) {
    Button button = new Button(group, 16400);
    button.setFont(group.getFont());
    button.setText(label);
    button.setData((null == value) ? label : value);
    GridData data = new GridData(768);
    data.horizontalAlignment = 4;
    data.verticalAlignment = 1;
    button.setLayoutData(data);
    if (null != listener)
      button.addSelectionListener(listener); 
    return button;
  }
  
  public static Button createPushButton(Composite parent, String label, int layoutMode, SelectionListener listener) {
    Button button = new Button(parent, 8);
    button.setFont(parent.getFont());
    button.setText(label);
    button.addSelectionListener(listener);
    GridData data = new GridData(layoutMode);
    button.setLayoutData(data);
    return button;
  }
  
  public static Text createTextField(Composite parent) {
    return createTextField(parent, 2052);
  }
  
  public static Text createTextField(Composite parent, int style) {
    Text text = new Text(parent, style);
    GridData data = new GridData();
    data.horizontalAlignment = 4;
    data.grabExcessHorizontalSpace = true;
    data.verticalAlignment = 2;
    data.grabExcessVerticalSpace = false;
    text.setLayoutData(data);
    return text;
  }
  
  public static Text createLongTextField(Composite parent, int span, int style) {
    Text text = new Text(parent, style);
    GridData data = new GridData();
    data.horizontalAlignment = 4;
    data.grabExcessHorizontalSpace = true;
    data.verticalAlignment = 4;
    data.grabExcessVerticalSpace = true;
    data.horizontalSpan = span;
    text.setLayoutData(data);
    return text;
  }
  
  public static Group createGroup(Composite parent, String label, int nColumns) {
    return createGroup(parent, label, nColumns, 768);
  }
  
  public static Group createGroup(Composite parent, String label, int nColumns, int style) {
    Group group = new Group(parent, 0);
    group.setFont(parent.getFont());
    group.setText(label);
    GridLayout layout = new GridLayout();
    layout.numColumns = nColumns;
    group.setLayout((Layout)layout);
    group.setLayoutData(new GridData(style));
    return group;
  }
  
  public static List createList(Composite parent, String strdata, String selData) {
    List list = new List(parent, 4);
    list.setFont(parent.getFont());
    GridData data = new GridData();
    list.setLayoutData(data);
    StringTokenizer st = new StringTokenizer(strdata, ",");
    while (st.hasMoreTokens())
      list.add(st.nextToken()); 
    if (selData == null) {
      if (list.getItemCount() > 0)
        list.select(0); 
    } else {
      selectList(list, selData);
    } 
    return list;
  }
  
  public static void selectList(List list, String selData) {
    int n_sel = list.indexOf(selData);
    if (0 > n_sel)
      n_sel = 0; 
    list.select(n_sel);
  }
  
  public static TableViewer createTableViewer(Composite parent, String[] opt_list, int width, int height, int style) {
    Composite composite = new Composite(parent, 0);
    TableColumnLayout tcl = new TableColumnLayout();
    composite.setLayout((Layout)tcl);
    GridData data = new GridData(1808);
    if (width != -1)
      data.widthHint = width; 
    if (height != -1)
      data.heightHint = height; 
    composite.setLayoutData(data);
    TableViewer listViewer = new TableViewer(composite, 0x800 | style);
    TableColumn column = new TableColumn(listViewer.getTable(), 0);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(100));
    if (null != opt_list && opt_list.length > 0)
      listViewer.add((Object[])opt_list); 
    return listViewer;
  }
  
  public static TableViewer createTableViewer(Composite parent, int width, int height, int style, String[] columns, int[] colWidths) {
    TableViewer listViewer = new TableViewer(parent, 0x800 | style);
    GridData data = new GridData(1808);
    if (width != -1)
      data.widthHint = width; 
    if (height != -1)
      data.heightHint = height; 
    listViewer.getTable().setLayoutData(data);
    Table table = listViewer.getTable();
    table.setHeaderVisible(true);
    table.setLinesVisible(true);
    TableLayout tableLayout = new TableLayout();
    for (int i = 0; i < columns.length; i++) {
      TableColumn column = new TableColumn(table, 0);
      column.setText(columns[i]);
      tableLayout.addColumnData((ColumnLayoutData)new ColumnWeightData(colWidths[i], true));
    } 
    table.setLayout((Layout)tableLayout);
    return listViewer;
  }
  
  public static void deactivateCellEditor(TableViewer viewer) {
    if (null == viewer)
      return; 
    CellEditor[] es = viewer.getCellEditors();
    TableItem[] items = viewer.getTable().getSelection();
    if (items.length >= 0)
      for (int i = 0; i < es.length; i++) {
        CellEditor e = es[i];
        Object value = e.getValue();
        if (e.isActivated() && viewer != null && viewer.getCellModifier() != null && value != null) {
          if (e.isValueValid()) {
            Object[] properties = viewer.getColumnProperties();
            viewer.cancelEditing();
            viewer.getCellModifier().modify(items[0], (String)properties[i], value);
            break;
          } 
          viewer.cancelEditing();
          break;
        } 
      }  
  }
  
  public static CheckboxTableViewer createCheckboxTableViewer(Composite parent, String[] opt_list, int width, int height, int style) {
    Table table = new Table(parent, 2080);
    table.setFont(parent.getFont());
    CheckboxTableViewer listViewer = new CheckboxTableViewer(table);
    GridData data = new GridData(style);
    if (width != -1)
      data.widthHint = width; 
    if (height != -1)
      data.heightHint = height; 
    if ((style & 0x4) != 0) {
      data.grabExcessHorizontalSpace = true;
      data.grabExcessVerticalSpace = true;
      data.horizontalAlignment = 256;
      data.verticalAlignment = 16;
    } 
    listViewer.getTable().setLayoutData(data);
    if (null != opt_list)
      listViewer.add((Object[])opt_list); 
    return listViewer;
  }
  
  public static CheckboxTableViewer createCheckboxTableViewer(Composite parent, int width, int height, int style, String[] columns, int[] colWidths) {
    CheckboxTableViewer listViewer = createCheckboxTableViewer(parent, null, width, height, style);
    Table table = listViewer.getTable();
    table.setFont(parent.getFont());
    table.setHeaderVisible(true);
    table.setLinesVisible(true);
    TableLayout tableLayout = new TableLayout();
    table.setLayout((Layout)tableLayout);
    TableColumn column = table.getColumn(0);
    column.setText(columns[0]);
    tableLayout.addColumnData((ColumnLayoutData)new ColumnWeightData(colWidths[0], false));
    for (int i = 1; i < columns.length; i++) {
      column = new TableColumn(table, 0);
      column.setText(columns[i]);
      tableLayout
        .addColumnData((ColumnLayoutData)new ColumnWeightData(colWidths[i], false));
    } 
    return listViewer;
  }
  
  public static CCombo createSelectCCombo(Composite parent, String strdata, String selData) {
    return createSelectCCombo(parent, strdata, selData, 2056);
  }
  
  public static CCombo createSelectCCombo(Composite parent, String strdata, String selData, int style) {
    CCombo combo = new CCombo(parent, style);
    combo.setFont(parent.getFont());
    GridData data = new GridData(768);
    combo.setLayoutData(data);
    StringTokenizer st = new StringTokenizer(strdata, ",");
    while (st.hasMoreTokens())
      combo.add(st.nextToken()); 
    if (selData == null || selData.length() == 0) {
      if (combo.getItemCount() > 0)
        combo.select(0); 
    } else {
      selectCCombo(combo, selData);
    } 
    return combo;
  }
  
  public static CCombo createSelectCCombo(Composite parent, String[] strdata, String selData) {
    return createSelectCCombo(parent, strdata, selData, 2060);
  }
  
  public static CCombo createSelectCCombo(Composite parent, String[] strdata, String selData, int style) {
    CCombo combo = new CCombo(parent, style);
    combo.setFont(parent.getFont());
    GridData data = new GridData(768);
    combo.setLayoutData(data);
    for (int i = 0; i < strdata.length; i++)
      combo.add(strdata[i]); 
    if (selData == null) {
      combo.select(0);
    } else {
      selectCCombo(combo, selData);
    } 
    return combo;
  }
  
  public static void selectCCombo(CCombo combo, String selData) {
    int n_sel = combo.indexOf(selData);
    if (0 > n_sel)
      n_sel = 0; 
    combo.select(n_sel);
  }
  
  public static Combo createSelectCombo(Composite parent, String strdata, String selData) {
    return createSelectCombo(parent, strdata, selData, 2056);
  }
  
  public static Combo createSelectCombo(Composite parent, String strdata, String selData, int style) {
    Combo combo = new Combo(parent, style);
    combo.setFont(parent.getFont());
    GridData data = new GridData(768);
    combo.setLayoutData(data);
    StringTokenizer st = new StringTokenizer(strdata, ",");
    while (st.hasMoreTokens())
      combo.add(st.nextToken()); 
    if (selData == null || selData.length() == 0) {
      if (combo.getItemCount() > 0)
        combo.select(0); 
    } else {
      selectCombo(combo, selData);
    } 
    return combo;
  }
  
  public static Combo createSelectCombo(Composite parent, String[] strdata, String selData) {
    return createSelectCombo(parent, strdata, selData, 2060);
  }
  
  public static Combo createSelectCombo(Composite parent, String[] strdata, String selData, int style) {
    Combo combo = new Combo(parent, style);
    combo.setFont(parent.getFont());
    GridData data = new GridData(768);
    combo.setLayoutData(data);
    for (int i = 0; i < strdata.length; i++)
      combo.add(strdata[i]); 
    if (selData == null) {
      combo.select(0);
    } else {
      selectCombo(combo, selData);
    } 
    return combo;
  }
  
  public static void selectCombo(Combo combo, String selData) {
    int n_sel = combo.indexOf(selData);
    if (0 > n_sel) {
      if ((combo.getStyle() & 0x8) == 0) {
        combo.setText(selData);
        return;
      } 
      n_sel = 0;
    } 
    combo.select(n_sel);
  }
  
  public static Shell createDialogShell() {
    Shell parent = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
    return new Shell(parent, 2144);
  }
  
  public static MessageBox createDialog(String title, String message, int style) {
    MessageBox box = new MessageBox(createDialogShell(), style | 0x10000);
    box.setText(title);
    box.setMessage(message);
    return box;
  }
  
  public static MessageBox createYesNoDialog(String title, String message) {
    return createDialog(title, message, 196);
  }
  
  public static MessageBox createOkDialog(String title, String message) {
    return createDialog(title, message, 34);
  }
  
  public static MessageBox createOkCancelDialog(String title, String message) {
    return createDialog(title, message, 290);
  }
  
  public static Button createCheckButton(Composite parent, String key, SelectionListener listener) {
    Button button = new Button(parent, 32);
    if (key != null)
      button.setText(JFaceResources.getString(key)); 
    button.setFont(parent.getFont());
    if (listener != null)
      button.addSelectionListener(listener); 
    return button;
  }
  
  public static ListViewer createListViewer(Composite c, String[] lines) {
    ListViewer lv = new ListViewer(c, 2816);
    List l = lv.getList();
    for (String s : lines)
      l.add(s); 
    GridData gd = new GridData(1808);
    l.setLayoutData(gd);
    return lv;
  }
  
  public static ListViewer createListViewer(Composite c, String[] lines, Font font, int maxHeightHintInLines, int maxWidthInChars) {
    ListViewer lv = new ListViewer(c, 2816);
    List l = lv.getList();
    l.setFont(font);
    int maxWidthSeen = 0;
    for (String s : lines) {
      if (s.length() > maxWidthSeen)
        maxWidthSeen = s.length(); 
      l.add(s);
    } 
    GridData gd = new GridData(1808);
    gd
      
      .heightHint = l.getItemHeight() * ((lines.length < maxHeightHintInLines) ? lines.length : maxHeightHintInLines);
    GC gc = new GC((Drawable)l);
    int avgCharWidth = gc.getFontMetrics().getAverageCharWidth();
    gc.dispose();
    gd
      
      .widthHint = avgCharWidth * ((maxWidthSeen < maxWidthInChars) ? maxWidthSeen : maxWidthInChars);
    l.setLayoutData(gd);
    return lv;
  }
  
  public static void setChildrenVisible(Composite composite, boolean visible) {
    for (Control c : composite.getChildren())
      c.setVisible(visible); 
  }
  
  public static void setEnabledRecursively(Control c, boolean enabled) {
    c.setEnabled(enabled);
    if (c instanceof Composite)
      for (Control child : ((Composite)c).getChildren())
        setEnabledRecursively(child, enabled);  
  }
  
  public static void setExpandedRecursively(Object treeOrTreeItem, boolean expand) {
    TreeItem[] tia;
    if (treeOrTreeItem instanceof Tree) {
      tia = ((Tree)treeOrTreeItem).getItems();
    } else {
      tia = new TreeItem[] { (TreeItem)treeOrTreeItem };
    } 
    for (TreeItem ti : tia) {
      ti.setExpanded(expand);
      for (TreeItem child : ti.getItems())
        setExpandedRecursively(child, expand); 
    } 
  }
  
  public static String trimmedValue(Text text) {
    String value = null;
    if (text != null) {
      value = text.getText().trim();
      if (value.length() == 0)
        value = null; 
    } 
    return value;
  }
  
  public static Object nvl(Object arg0, Object arg1) {
    return (arg0 != null) ? arg0 : arg1;
  }
  
  public static Label createEmptyLabel(Composite parent) {
    Label lbl = new Label(parent, 0);
    lbl.setLayoutData(new GridData(4, 16777216, false, false));
    return lbl;
  }
  
  public static Composite createEmptyPanel(Composite parent) {
    return createEmptyPanel(parent, "");
  }
  
  public static Composite createEmptyPanel(Composite parent, String fictiveStringToSetWidth) {
    Composite hlpComposite = new Composite(parent, 0);
    hlpComposite
      .setLayoutData(new GridData(4, 4, true, false));
    StackLayout hlpStackLayout = new StackLayout();
    hlpComposite.setLayout((Layout)hlpStackLayout);
    Label hlpEmptyLabel = createEmptyLabel(hlpComposite);
    Text hlpFictiveText = createGridText(hlpComposite, 1, 0, null, 0);
    hlpFictiveText.setText(fictiveStringToSetWidth);
    hlpStackLayout.topControl = (Control)hlpEmptyLabel;
    return hlpComposite;
  }
  
  public static Combo createGridCombo(Composite parent, int horizontalSpan, int widthHint, SelectionListener selectionListener, ModifyListener modifyListener, int style) {
    Combo combo = new Combo(parent, style);
    GridData data = new GridData(4, 16777216, true, false);
    if (horizontalSpan > 0)
      data.horizontalSpan = horizontalSpan; 
    if (widthHint > 0)
      data.widthHint = widthHint; 
    combo.setLayoutData(data);
    if (selectionListener != null)
      combo.addSelectionListener(selectionListener); 
    if (modifyListener != null)
      combo.addModifyListener(modifyListener); 
    return combo;
  }
  
  public static Combo createGridEnumCombo(Composite parent, int horizontalSpan, int widthHint, Enum<?>[] values, SelectionListener selectionListener, ModifyListener modifyListener, int style) {
    Combo combo = createGridCombo(parent, horizontalSpan, widthHint, selectionListener, modifyListener, style);
    for (Enum<?> value : values)
      combo.add(value.toString()); 
    combo.select(0);
    return combo;
  }
  
  public static Label createGridLabel(Composite parent, String string, int horizontalSpan, int widthHint, int style) {
    Label lbl = new Label(parent, style);
    GridData data = new GridData(4, 16777216, false, false);
    if (widthHint > 0)
      data.widthHint = widthHint; 
    if (horizontalSpan > 1)
      data.horizontalSpan = horizontalSpan; 
    lbl.setLayoutData(data);
    lbl.setText(string);
    return lbl;
  }
  
  public static Text createGridText(Composite parent, int horizontalSpan, int widthHint, ModifyListener listener, int style) {
    return createNoBorderGridText(parent, horizontalSpan, widthHint, listener, 0x800 | style);
  }
  
  public static Text createNoBorderGridText(Composite parent, int horizontalSpan, int widthHint, ModifyListener listener, int style) {
    Text text = new Text(parent, style);
    GridData data = new GridData(4, 16777216, true, false);
    if (horizontalSpan > 0)
      data.horizontalSpan = horizontalSpan; 
    if (widthHint > 0)
      data.widthHint = widthHint; 
    text.setLayoutData(data);
    if (listener != null)
      text.addModifyListener(listener); 
    return text;
  }
  
  public static void setColor(Color systemColor, Label... labels) {
    for (Label lb : labels)
      lb.setForeground(systemColor); 
  }
  
  public static void setEditable(boolean b, Text... fields) {
    for (Text t : fields)
      t.setEditable(b); 
  }
}
